package threadTest;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.Future;

import org.junit.BeforeClass;
import org.junit.Test;

public class ExecutorServiceTest {
	private static int[] arr;
	
	
	@BeforeClass
	public static void beforeClass(){
		int size = 20000_0000;
		arr = ArrayUtil.generateIntArr(size);
		
	}
	
	@Test
	public void test() {
		System.out.println("test="+ArrayUtil.findMax(arr));
	}
	
    /*手动分解任务*/
	@Test
	public void testCallable() throws InterruptedException, ExecutionException{
		int numberOfProcessor = Runtime.getRuntime().availableProcessors();
		int[] range = ArrayUtil.generateRange(arr.length, numberOfProcessor);
		List<FindMaxTask> taskList =  new ArrayList<>();
		for (int i = 0; i < range.length-1; i++) {
			FindMaxTask findMaxTask = new FindMaxTask(arr,range[i],range[i+1]);
			taskList.add(findMaxTask);
		}
		ExecutorService batchExecutor = Executors.newCachedThreadPool();
		List<Future<Integer>> futureTasks = batchExecutor.invokeAll(taskList);
		Integer result = arr[0];
		for (Future<Integer> future : futureTasks) {
			Integer temp = future.get();
			if(result<temp)
				result = temp;
		}
		System.out.println("testCallable()="+result);
	}
	
    
    /*适用ForkJoinPool自动分解任务*/
	@Test
	public void testForkJoinPoolTest(){
		
		FindInArrTask findMaxTask = new FindInArrTask(arr, 0, arr.length-1);
		ForkJoinPool pool = new ForkJoinPool();
		System.out.println("testForkJoinPoolTest()="+pool.invoke(findMaxTask));
	}

}


