public class ProducerConsumerTest {

	public static void main(String[] args) {
		ProducerConsumerPool pool = new ProducerConsumerPool();
		ProducerConsumerPool.Producer p1 = pool.new Producer();
		ProducerConsumerPool.Consumer c1 = pool.new Consumer();
		Thread t1 = new Thread(p1);
		Thread t2 = new Thread(c1);
		t1.start();
		t2.start();
		System.out.println("Starting!");
		}
}

class ProducerConsumerPool{
	private static final int ITEMS = 1000;
	private int count=0;
	public  int  getCount(){
		return count;
	}
	public  void setCount(int i){
		count = i;
	}
	public  void produce(){  //synchronizedͬ
		setCount(getCount()+1);
	}
	public  void consume(){  //synchronizedͬ
		setCount(getCount()-1);
	}
	
	public class Producer implements Runnable {
		public void run() {
			try{
				for (int i = 0; i < ITEMS; i++){
					produce();
					Thread.sleep(2);
				}
			}catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			System.out.println(Thread.currentThread().getName()+" produed "+ITEMS+ " now the count is "+count);
		}
	}

	public class Consumer implements Runnable {
		public void run() {
			try {
				for (int i = 0; i < ITEMS; i++){
					consume();
					Thread.sleep(2);
				}
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			System.out.println(Thread.currentThread().getName()+" consumed "+ITEMS+ " now the count is "+count);
		}
	}
}
